#!/bin/sh
PWD=`pwd`
VERSION="0.0.15"
ARCH=SPARC

rm -rf build
/bin/sh ClearPackage.sh
cmake -DSKIP_RELINK_RPATH=ON . -DCMAKE_INSTALL_PREFIX=/opt/csw -DCFLAGS="${CFLAGS}" -DCXXFLAGS="${CXXFLAGS}"
make
mkdir build
make DESTDIR=build install

# Lib
cd $PWD/Solaris/CMNClibzeromime00
sed s/%VERSION%/$VERSION/g Prototype.tpl > Prototype
sed s/%VERSION%/$VERSION/g pkginfo.tpl > pkginfo
pkgmk -o -r $PWD/build/opt/csw -d $PWD/build -f Prototype
rm pkginfo Prototype

# Dev
cd $PWD/Solaris/CMNClibzeromime-dev
sed s/%VERSION%/$VERSION/g pkginfo.tpl > pkginfo
pkgmk -o -r $PWD/build/opt/csw -d $PWD/build -f Prototype
rm pkginfo

cd $PWD/build
tar -cf - CMNClibzeromime00 | gzip -9 -c > CMNClibzeromime00.$VERSION.$ARCH.pkg.tar.gz
tar -cf - CMNClibzeromime-dev | gzip -9 -c > CMNClibzeromime-dev.$VERSION.$ARCH.pkg.tar.gz
rm -fr opt
cd $PWD
