/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#ifndef _ZM_DATA_BUFFER_IMPL_H__
#define _ZM_DATA_BUFFER_IMPL_H__ 1

/**
 * @file zm_data_buffer_impl.h
 * @brief Iris data buffer, internal implementation
 */
#include "zm_data_buffer.h"
#include "zm_data_buffer_impl_defs.h"
#include "zm_mem_defs.h"

#ifdef __cplusplus
extern "C"
{
#endif

/**
 * @struct _zm_data_buffer zm_data_buffer.h <zm_data_buffer.h>
 * @brief Data buffer, internal implementation
 */
struct ZM_API _zm_data_buffer_impl
{
	/* Array size                  */
	int64_t           size;
	/* Array size                  */
	int64_t           capacity;
	/* Data                        */
	char            * data;

	/** Opaque data allocator      */
	ZM_ALLOCATOR    * alloc;
};

/**
 * @brief Create data buffer default implementation
 * @param data_buffer - Data buffer object
 * @param alloc - Memory allocator
 * @return Pointer to the data buffer
 */
ZM_DATA_BUFFER * zm_data_buffer_create_impl(ZM_DATA_BUFFER  * data_buffer,
                                            ZM_ALLOCATOR    * alloc);

#ifdef __cplusplus
}
#endif

#endif /* _ZM_DATA_BUFFER_IMPL_H__ */
/* End */
