/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#ifndef _ZM_PARSER_H__
#define _ZM_PARSER_H__ 1

/**
  @file zm_parser.h
  @brief Zero MIME parser
*/

#include "zm_aliases_defs.h"
#include "zm_mem_defs.h"
#include "zm_struct_defs.h"

#ifdef __cplusplus
extern "C"
{
#endif

/**
 * @brief Parse MIME message
 * @param msg - Message
 * @param msg_len - Message length
 * @param alloc - Memory allocator
 * @param ignore_errors - If set to 1 ignore paser errors
 * @param charset_aliases - If not null, use aliases database for charset recognition
 * @param part - MIME part data structure [out]
 * @return Status code, @see zm_struct.h
 */
int32_t zm_parse_mime(const void     * msg,
                      uint64_t         msg_len,
                      ZM_ALLOCATOR   * alloc,
                      int32_t          ignore_errors,
                      ZM_ALIASES     * charset_aliases,
                      ZM_PART       ** part);

#ifdef __cplusplus
}
#endif

#endif /* _ZM_PARSER_H__ */
/* End. */
