/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include "zm_block.h"

/*
 * Create data block
 */
void zm_block_create(ZM_BLOCK  * block,
                     uint64_t    start,
                     uint64_t    end)
{
	block -> start = start;
	block -> end   = end;
}

/*
 * Create empty block
 */
void zm_block_zero(ZM_BLOCK  * block)
{
	zm_block_create(block, 0, 0);
}

/*
 * Copy block
 */
void zm_block_copy(ZM_BLOCK        * block_dst,
                   const ZM_BLOCK  * block_src)
{
	block_dst -> start = block_src -> start;
	block_dst -> end   = block_src -> end;
}

/*
 * Get data from block
 */
const void * zm_block_get_data(const ZM_BLOCK  * block,
                               const void      * data,
                               uint64_t        * len)
{
	*len = block -> end - block -> start;

return (unsigned char *)data + block -> start;
}
/* End. */
