/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <string.h>
#include <strings.h>

#include "zm_rbtree_cmp.h"

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_void_cmp(void        * opaque,
                   const void  * x,
                   const void  * y)
{
	const char  * xx = (const char  *)x;
	const char  * yy = (const char  *)y;

return xx - yy;
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_string_cmp(void        * opaque,
                       const void  * x,
                       const void  * y)
{
	const char  * xx = (const char  *)x;
	const char  * yy = (const char  *)y;

return strcmp(xx, yy);
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_string_case_cmp(void        * opaque,
                          const void  * x,
                          const void  * y)
{
	const char  * xx = (const char  *)x;
	const char  * yy = (const char  *)y;

return strcasecmp(xx, yy);
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_int32_cmp(void        * opaque,
                    const void  * x,
                    const void  * y)
{
	int32_t  * xx = (int32_t *)x;
	int32_t  * yy = (int32_t *)y;

return *xx - *yy;
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_uint32_cmp(void        * opaque,
                     const void  * x,
                     const void  * y)
{
	uint32_t  * xx = (uint32_t *)x;
	uint32_t  * yy = (uint32_t *)y;

return *xx - *yy;
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_int64_cmp(void        * opaque,
                    const void  * x,
                    const void  * y)
{
	int64_t  * xx = (int64_t *)x;
	int64_t  * yy = (int64_t *)y;

return *xx - *yy;
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_uint64_cmp(void        * opaque,
                     const void  * x,
                     const void  * y)
{
	uint64_t  * xx = (uint64_t *)x;
	uint64_t  * yy = (uint64_t *)y;

return *xx - *yy;
}

/*
 * Compare(a,b) should return 1 if *a > *b, -1 if *a < *b, and 0 otherwise
 */
int zm_rb_pointer_cmp(void        * opaque,
                      const void  * x,
                      const void  * y)
{
	const char  * xx = (const char  *)x;
	const char  * yy = (const char  *)y;

return xx - yy;
}
/* End */
