/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <stdlib.h>

#include "zm_rbtree_fn.h"
#include "zm_mem.h"

/*
 * Do not destroy key and value
 */
void zm_rb_destroy_null(void  * opaque,
                        void  * key,
                        void  * val)
{
	/* Do nothing */
	;;
}

/*
 * Deallocate key only
 */
void zm_rb_destroy_key(void  * opaque,
                       void  * key,
                       void  * val)
{
	ZM_ALLOCATOR  * alloc = (ZM_ALLOCATOR *)opaque;

	alloc -> deallocate(alloc -> opaque, key);
}

/*
 * Deallocate value only
 */
void zm_rb_destroy_val(void  * opaque,
                       void  * key,
                       void  * val)
{
	ZM_ALLOCATOR  * alloc = (ZM_ALLOCATOR *)opaque;

	alloc -> deallocate(alloc -> opaque, val);
}

/*
 * Deallocate key and value
 */
void zm_rb_destroy_key_val(void  * opaque,
                           void  * key,
                           void  * val)
{
	ZM_ALLOCATOR  * alloc = (ZM_ALLOCATOR *)opaque;

	alloc -> deallocate(alloc -> opaque, key);
	alloc -> deallocate(alloc -> opaque, val);
}

/* End */
