/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sysexits.h>

#include "zm_mem.h"
#include "zm_time_parser.h"

int main(int argc, char ** argv)
{
	int64_t      ts          = 0;
	int64_t      ts_offset   = 0;
	int64_t      t_ts        = 0;
	int64_t      t_ts_offset = 0;

	ZM_ABBREV  * abbrev      = NULL;
	int32_t      rc          = 0;
	int32_t      code        = EX_SOFTWARE;

	if (argc != 5) { fprintf(stderr, "usage: %s tz/abbrev.txt 'Wed, 19 Jun 2024 13:39:25 +0000' 1718800765 0\n", argv[0]); return EX_USAGE; }

	if (zm_load_abbrev(argv[1], &zm_default_allocator, &abbrev) == -1) { return -1; }

	zm_print_abbrev(abbrev);

	t_ts        = atol(argv[3]);
	t_ts_offset = atol(argv[4]);

	rc = zm_parse_datetime(argv[2], strlen(argv[2]), &ts, &ts_offset, abbrev);
	if (rc == 0)
	{
		if ((ts == t_ts) && (ts_offset == t_ts_offset))
		{
			code = EX_OK;
		}
		else
		{
			rc = 1;
		}

		fprintf(stdout, "%s: (%i %i) %s (%i %i)\n", argv[2],
		                                            (int32_t)ts, (int32_t)ts_offset,
		                                            (rc == 0) ? ".EQ." : ".NE.",
		                                            (int32_t)t_ts, (int32_t)t_ts_offset);
	}

	zm_free_abbrev(abbrev);

return code;
}
/* End. */
