/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <stdio.h>
#include <string.h>
#include <sysexits.h>

#include "zm_mem.h"
#include "zm_aliases.h"

int main(int argc, char ** argv)
{
	const char  * name    = NULL;
	ZM_ALIASES  * aliases = NULL;
	int32_t       rc      = 0;
	int32_t       code    = EX_SOFTWARE;

	if (argc != 4) { fprintf(stderr, "usage: %s charsets/aliases.txt UTF_8 UTF-8\n", argv[0]); return EX_USAGE; }

	if (zm_load_aliases(argv[1], &zm_default_allocator, &aliases) == -1) { return -1; }

	zm_print_aliases(aliases);

	rc = zm_parse_alias(aliases, argv[2], strlen(argv[2]), &name);
	if (rc == 0)
	{
		rc = strcmp(name, argv[3]);
		fprintf(stdout, "`%s` -> `%s` %s `%s`\n", argv[2], name, (rc == 0) ? ".EQ." : ".NE.", argv[3]);
		code = EX_OK;

	}
	else
	{
		fprintf(stdout, "`%s` -> NULL\n", argv[2]);
		code = EX_OK;
	}

	zm_free_aliases(aliases);
return code;
}
/* End. */
