/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <stdio.h>
#include <string.h>
#include <sysexits.h>

#include "zm_mem.h"
#include "zm_iconv.h"

int main(int argc, char ** argv)
{
	ZM_ICONV        iconv;

	void           * result     = NULL;
	uint64_t         result_len = 0;

	uint32_t         errors     = 0;
	int32_t          rc         = 0;
	int32_t          code       = EX_SOFTWARE;

	if (argc != 5) { fprintf(stderr, "usage: %s HelloWorldПриветМИРHelloHello UTF-8 UTF_7 'HelloWorld+BB8EQAQ4BDIENQRCBBwEGAQg-HelloHello'\n", argv[0]); return EX_USAGE; }

	zm_iconv_create(&iconv, &zm_default_allocator);

	zm_iconv_add_alias(&iconv, "UTF-8", "UTF");
	zm_iconv_add_alias(&iconv, "UTF-8", "UTF8");

	zm_iconv_add_alias(&iconv, "UTF-7", "UTF_7");
	zm_iconv_add_alias(&iconv, "UTF-7", "UTF7");

	rc = zm_iconv_convert(&iconv, argv[1], strlen(argv[1]), &result, &result_len, argv[2], argv[3], &errors, 1);
	if (rc == 0)
	{
		rc = strncmp(result, argv[4], result_len);

		fprintf(stdout, "`%.*s` %s `%s`\n\n", (int32_t)result_len, (const char *)result, (rc == 0) ? ".EQ." : ".NE.", argv[4]);

		zm_deallocate(&zm_default_allocator, result);

		if (rc == 0) { code = EX_OK; }
	}

	zm_iconv_destroy(&iconv);

return code;
}
/* End. */
