/*-
 *  Copyright (c) Iris Dev. team. All rights reserved.
 *  See http://www.communico.pro/products/zeromime/license/ for details.
 *
 */
#include <stdio.h>
#include <string.h>
#include <sysexits.h>

#include "zm_data_buffer_impl.h"
#include "zm_iconv.h"
#include "zm_mem.h"
#include "zm_mime_converter.h"

int main(int argc, char ** argv)
{
	ZM_ICONV          iconv;
	ZM_DATA_BUFFER    dst;

	const char      * dst_str  = NULL;
	int32_t           dst_len  = 0;
	int32_t           rc       = 0;

	if (argc != 3) { fprintf(stderr, "usage: %s '=?UTF-8?B?SGVsbG8gd29ybGQh?=' 'Hello world!'\n", argv[0]); return EX_USAGE; }

	zm_iconv_create(&iconv, &zm_default_allocator);

	zm_data_buffer_create_impl(&dst, &zm_default_allocator);

	zm_decode_mime_encoded((const unsigned char *)argv[1], strlen(argv[1]), &dst, &iconv);

	dst_str = zm_data_buffer_get(&dst);
	dst_len = zm_data_buffer_get_size(&dst);

	rc = strncmp(dst_str, argv[2], dst_len);

	fprintf(stdout, "`%.*s` %s `%s`\n\n", dst_len, dst_str, (rc == 0) ? ".EQ." : ".NE.", argv[2]);

	zm_data_buffer_destroy(&dst);

	if (rc != 0) { return EX_SOFTWARE; }

return EX_OK;
}
/* End. */
