Name: libzeromime
Version: 0.0.15
Release: 3%{?dist}
Epoch: 1

Summary: ZeroMIME, lighweight MIME parser
Group: Applications/Internet
URL: https://www.communico.pro/devel/zeromime

License: BSD 2-clause and proprietary

Source0: http://www.communico.pro/download/pub/zeromime/libzeromime-%{version}.tar.gz

BuildRequires: cmake

Requires: fileutils, bash

Provides: libzeromime = %{epoch}:%{version}-%{release}
Provides: libzeromime%{?_isa} = %{epoch}:%{version}-%{release}
Obsoletes: libzeromime < %{obsoleted_zeromime_evr}

%global _default_patch_flags --no-backup-if-mismatch

%description
ZeroMIME is lighweight MIME parser. It helps to manipulate
with MIME structures with low memory and CPU overhead.

%package devel

Summary: ZeroMIME header files and documentation
Group: Applications/Internet
Requires: %{name}%{?_isa} = %{epoch}:%{version}-%{release}
Provides: libzeromime-devel = %{epoch}:%{version}-%{release}
Provides: libzeromime-devel%{?_isa} = %{epoch}:%{version}-%{release}
Obsoletes: libzeromime-devel < %{obsoleted_zeromime_evr}

%description devel
ZeroMIME header files and documentation
ZeroMIME is lighweight MIME parser. It helps to manipulate
with MIME structures with low memory and CPU overhead.

%prep
%setup -q -n libzeromime-%{version}

%build

CFLAGS="%{optflags} -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE"
CXXFLAGS="$CFLAGS"
export CFLAGS CXXFLAGS

cmake . -DCMAKE_INSTALL_PREFIX="%{_prefix}" \
        -DINSTALL_LIBDIR:STRING="%{_libdir}"
make %{?_smp_mflags}

%check

%install
make DESTDIR=$RPM_BUILD_ROOT install

chmod 0755 $RPM_BUILD_ROOT%{_libdir}/lib*.so.*
find $RPM_BUILD_ROOT -print | sed "s|^$RPM_BUILD_ROOT||" | sort > ROOTFILES

#install -p -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d
#echo "%{_libdir}/zeromime" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/%{name}-%{_arch}.conf

%post devel

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%{_libdir}/libzeromime.so.*
%{_datadir}/*

%files devel
%{_includedir}/zeromime/*
%{_libdir}/*.a
%{_libdir}/*.so

%changelog
* Fri Jun 21 2024 Andrey V. Shetukhin <stellar@communico.pro> 0.0.15
- Bug fixes
- Examples
- Test suite

* Wed Jul 18 2018 Andrey V. Shetukhin <stellar@communico.pro> 0.0.14
- Bug fixes

* Fri Jun  9 2017 Andrey V. Shetukhin <stellar@communico.pro> 0.0.12
- Bug fixes

* Tue Jun  6 2017 Andrey V. Shetukhin <stellar@communico.pro> 0.0.10
- Bug fixes

* Fri May 26 2017 Andrey V. Shetukhin <stellar@communico.pro> 0.0.9
- Bug fixes

* Sat Jan 23 2016 Andrey V. Shetukhin <stellar@communico.pro> 0.0.8
- Package for RHEL
